diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-remote-station-manager.cc ns-3.39/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.38/src/wifi/model/wifi-remote-station-manager.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-remote-station-manager.cc	2023-07-05 14:23:48.125428400 -0700
@@ -30,6 +30,7 @@
 #include "ns3/boolean.h"
 #include "ns3/eht-configuration.h"
 #include "ns3/enum.h"
+#include "ns3/erp-ofdm-phy.h"
 #include "ns3/he-configuration.h"
 #include "ns3/ht-configuration.h"
 #include "ns3/ht-phy.h"
@@ -552,6 +553,18 @@
     return staId;
 }
 
+bool
+WifiRemoteStationManager::IsInPsMode(const Mac48Address& address) const
+{
+    return LookupState(address)->m_isInPsMode;
+}
+
+void
+WifiRemoteStationManager::SetPsMode(const Mac48Address& address, bool isInPsMode)
+{
+    LookupState(address)->m_isInPsMode = isInPsMode;
+}
+
 void
 WifiRemoteStationManager::SetMldAddress(const Mac48Address& address, const Mac48Address& mldAddress)
 {
@@ -734,6 +747,39 @@
     return v;
 }
 
+void
+WifiRemoteStationManager::AdjustTxVectorForIcf(WifiTxVector& txVector) const
+{
+    NS_LOG_FUNCTION(this << txVector);
+
+    auto txMode = txVector.GetMode();
+    if (txMode.GetModulationClass() >= WIFI_MOD_CLASS_HT)
+    {
+        auto rate = txMode.GetDataRate(txVector);
+        if (rate >= 24e6)
+        {
+            rate = 24e6;
+        }
+        else if (rate >= 12e6)
+        {
+            rate = 12e6;
+        }
+        else
+        {
+            rate = 6e6;
+        }
+        txVector.SetPreambleType(WIFI_PREAMBLE_LONG);
+        if (m_wifiPhy->GetPhyBand() == WIFI_PHY_BAND_2_4GHZ)
+        {
+            txVector.SetMode(ErpOfdmPhy::GetErpOfdmRate(rate));
+        }
+        else
+        {
+            txVector.SetMode(OfdmPhy::GetOfdmRate(rate));
+        }
+    }
+}
+
 WifiTxVector
 WifiRemoteStationManager::GetAckTxVector(Mac48Address to, const WifiTxVector& dataTxVector) const
 {
@@ -1376,11 +1422,14 @@
     state->m_vhtCapabilities = nullptr;
     state->m_heCapabilities = nullptr;
     state->m_ehtCapabilities = nullptr;
+    state->m_emlCapabilities = nullptr;
+    state->m_emlsrEnabled = false;
     state->m_channelWidth = m_wifiPhy->GetChannelWidth();
     state->m_guardInterval = GetGuardInterval();
     state->m_ness = 0;
     state->m_aggregation = false;
     state->m_qosSupported = false;
+    state->m_isInPsMode = false;
     const_cast<WifiRemoteStationManager*>(this)->m_states.insert({address, state});
     NS_LOG_DEBUG("WifiRemoteStationManager::LookupState returning new state");
     return state;
@@ -1419,6 +1468,13 @@
 }
 
 void
+WifiRemoteStationManager::SetEmlsrEnabled(const Mac48Address& from, bool emlsrEnabled)
+{
+    NS_LOG_FUNCTION(this << from << emlsrEnabled);
+    LookupState(from)->m_emlsrEnabled = emlsrEnabled;
+}
+
+void
 WifiRemoteStationManager::AddStationHtCapabilities(Mac48Address from, HtCapabilities htCapabilities)
 {
     // Used by all stations to record HT capabilities of remote stations
@@ -1543,6 +1599,15 @@
     SetQosSupport(from, true);
 }
 
+void
+WifiRemoteStationManager::AddStationEmlCapabilities(
+    Mac48Address from,
+    const std::shared_ptr<CommonInfoBasicMle::EmlCapabilities>& emlCapabilities)
+{
+    NS_LOG_FUNCTION(this << from);
+    LookupState(from)->m_emlCapabilities = emlCapabilities;
+}
+
 Ptr<const HtCapabilities>
 WifiRemoteStationManager::GetStationHtCapabilities(Mac48Address from)
 {
@@ -1567,6 +1632,12 @@
     return LookupState(from)->m_ehtCapabilities;
 }
 
+std::shared_ptr<CommonInfoBasicMle::EmlCapabilities>
+WifiRemoteStationManager::GetStationEmlCapabilities(const Mac48Address& from)
+{
+    return LookupState(from)->m_emlCapabilities;
+}
+
 bool
 WifiRemoteStationManager::GetLdpcSupported(Mac48Address address) const
 {
@@ -1940,6 +2011,19 @@
     return (bool)(station->m_state->m_ehtCapabilities);
 }
 
+bool
+WifiRemoteStationManager::GetEmlsrSupported(const WifiRemoteStation* station) const
+{
+    auto emlCapabilities = station->m_state->m_emlCapabilities;
+    return emlCapabilities && emlCapabilities->emlsrSupport == 1;
+}
+
+bool
+WifiRemoteStationManager::GetEmlsrEnabled(const WifiRemoteStation* station) const
+{
+    return station->m_state->m_emlsrEnabled;
+}
+
 uint8_t
 WifiRemoteStationManager::GetNMcsSupported(const WifiRemoteStation* station) const
 {
@@ -2041,6 +2125,23 @@
     return (bool)(LookupState(address)->m_ehtCapabilities);
 }
 
+bool
+WifiRemoteStationManager::GetEmlsrSupported(const Mac48Address& address) const
+{
+    auto emlCapabilities = LookupState(address)->m_emlCapabilities;
+    return emlCapabilities && emlCapabilities->emlsrSupport == 1;
+}
+
+bool
+WifiRemoteStationManager::GetEmlsrEnabled(const Mac48Address& address) const
+{
+    if (auto stateIt = m_states.find(address); stateIt != m_states.cend())
+    {
+        return stateIt->second->m_emlsrEnabled;
+    }
+    return false;
+}
+
 void
 WifiRemoteStationManager::SetDefaultTxPowerLevel(uint8_t txPower)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-remote-station-manager.h ns-3.39/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.38/src/wifi/model/wifi-remote-station-manager.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-remote-station-manager.h	2023-07-05 14:23:48.125428400 -0700
@@ -30,6 +30,7 @@
 #include "ns3/he-capabilities.h"
 #include "ns3/ht-capabilities.h"
 #include "ns3/mac48-address.h"
+#include "ns3/multi-link-element.h"
 #include "ns3/object.h"
 #include "ns3/traced-callback.h"
 #include "ns3/vht-capabilities.h"
@@ -113,6 +114,9 @@
     Ptr<const VhtCapabilities> m_vhtCapabilities; //!< remote station VHT capabilities
     Ptr<const HeCapabilities> m_heCapabilities;   //!< remote station HE capabilities
     Ptr<const EhtCapabilities> m_ehtCapabilities; //!< remote station EHT capabilities
+    /// remote station EML capabilities
+    std::shared_ptr<CommonInfoBasicMle::EmlCapabilities> m_emlCapabilities;
+    bool m_emlsrEnabled; //!< whether EMLSR mode is enabled on this link
 
     uint16_t m_channelWidth;  //!< Channel width (in MHz) supported by the remote station
     uint16_t m_guardInterval; //!< HE Guard interval duration (in nanoseconds) supported by the
@@ -122,6 +126,7 @@
     bool m_shortPreamble;     //!< Flag if short PHY preamble is supported by the remote station
     bool m_shortSlotTime;     //!< Flag if short ERP slot time is supported by the remote station
     bool m_qosSupported;      //!< Flag if QoS is supported by the station
+    bool m_isInPsMode;        //!< Flag if the STA is currently in PS mode
 };
 
 /**
@@ -232,6 +237,11 @@
      */
     void SetQosSupport(Mac48Address from, bool qosSupported);
     /**
+     * \param from the address of the station being recorded
+     * \param emlsrEnabled whether EMLSR mode is enabled for the station on this link
+     */
+    void SetEmlsrEnabled(const Mac48Address& from, bool emlsrEnabled);
+    /**
      * Records HT capabilities of the remote station.
      *
      * \param from the address of the station being recorded
@@ -260,6 +270,15 @@
      */
     void AddStationEhtCapabilities(Mac48Address from, EhtCapabilities ehtCapabilities);
     /**
+     * Records EML capabilities of the remote station.
+     *
+     * \param from the address of the station being recorded
+     * \param emlCapabilities the EML capabilities of the station
+     */
+    void AddStationEmlCapabilities(
+        Mac48Address from,
+        const std::shared_ptr<CommonInfoBasicMle::EmlCapabilities>& emlCapabilities);
+    /**
      * Return the HT capabilities sent by the remote station.
      *
      * \param from the address of the remote station
@@ -288,6 +307,12 @@
      */
     Ptr<const EhtCapabilities> GetStationEhtCapabilities(Mac48Address from);
     /**
+     * \param from the (MLD or link) address of the remote non-AP MLD
+     * \return the EML Capabilities advertised by the remote non-AP MLD
+     */
+    std::shared_ptr<CommonInfoBasicMle::EmlCapabilities> GetStationEmlCapabilities(
+        const Mac48Address& from);
+    /**
      * Return whether the device has HT capability support enabled.
      *
      * \return true if HT capability support is enabled, false otherwise
@@ -609,6 +634,16 @@
      *         false otherwise
      */
     bool GetEhtSupported(Mac48Address address) const;
+    /**
+     * \param address the (MLD or link) address of the non-AP MLD
+     * \return whether the non-AP MLD supports EMLSR
+     */
+    bool GetEmlsrSupported(const Mac48Address& address) const;
+    /**
+     * \param address the (MLD or link) address of the non-AP MLD
+     * \return whether EMLSR mode is enabled for the non-AP MLD on this link
+     */
+    bool GetEmlsrEnabled(const Mac48Address& address) const;
 
     /**
      * Return a mode for non-unicast packets.
@@ -734,6 +769,22 @@
     void RecordAssocRefused(Mac48Address address);
 
     /**
+     * Return whether the STA is currently in Power Save mode.
+     *
+     * \param address the address of the station
+     *
+     * \return true if the station is in Power Save mode, false otherwise
+     */
+    bool IsInPsMode(const Mac48Address& address) const;
+    /**
+     * Register whether the STA is in Power Save mode or not.
+     *
+     * \param address the address of the station
+     * \param isInPsMode whether the STA is in PS mode or not
+     */
+    void SetPsMode(const Mac48Address& address, bool isInPsMode);
+
+    /**
      * Set the address of the MLD the given station is affiliated with.
      *
      * \param address the MAC address of the remote station
@@ -792,6 +843,13 @@
      */
     WifiTxVector GetCtsToSelfTxVector();
     /**
+     * Adjust the TXVECTOR for an initial Control frame to ensure that the modulation class
+     * is non-HT and the rate is 6 Mbps, 12 Mbps or 24 Mbps.
+     *
+     * \param txVector the TXVECTOR to adjust
+     */
+    void AdjustTxVectorForIcf(WifiTxVector& txVector) const;
+    /**
      * Return a TXVECTOR for the Ack frame given the destination and the mode of the Data
      * used by the sender.
      *
@@ -1097,6 +1155,16 @@
      */
     bool GetEhtSupported(const WifiRemoteStation* station) const;
     /**
+     * \param station the station of a non-AP MLD
+     * \return whether the non-AP MLD supports EMLSR
+     */
+    bool GetEmlsrSupported(const WifiRemoteStation* station) const;
+    /**
+     * \param station the station of a non-AP MLD
+     * \return whether EMLSR mode is enabled for the non-AP MLD on this link
+     */
+    bool GetEmlsrEnabled(const WifiRemoteStation* station) const;
+    /**
      * Return the WifiMode supported by the specified station at the specified index.
      *
      * \param station the station being queried
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-spectrum-phy-interface.cc ns-3.39/src/wifi/model/wifi-spectrum-phy-interface.cc
--- ns-3.38/src/wifi/model/wifi-spectrum-phy-interface.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-spectrum-phy-interface.cc	2023-07-05 14:23:48.125428400 -0700
@@ -19,11 +19,10 @@
 
 #include "wifi-spectrum-phy-interface.h"
 
-#include "spectrum-wifi-phy.h"
-
 #include "ns3/log.h"
 #include "ns3/mobility-model.h"
 #include "ns3/net-device.h"
+#include "ns3/spectrum-channel.h"
 #include "ns3/spectrum-value.h"
 
 NS_LOG_COMPONENT_DEFINE("WifiSpectrumPhyInterface");
@@ -41,18 +40,26 @@
     return tid;
 }
 
-WifiSpectrumPhyInterface::WifiSpectrumPhyInterface()
+WifiSpectrumPhyInterface::WifiSpectrumPhyInterface(FrequencyRange freqRange)
+    : m_frequencyRange{freqRange},
+      m_centerFrequency{0},
+      m_channelWidth{0},
+      m_bands{},
+      m_ruBands{}
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << freqRange);
 }
 
 void
 WifiSpectrumPhyInterface::DoDispose()
 {
     NS_LOG_FUNCTION(this);
+    m_rxSpectrumModel = nullptr;
     m_spectrumWifiPhy = nullptr;
     m_netDevice = nullptr;
     m_channel = nullptr;
+    m_bands.clear();
+    m_ruBands.clear();
 }
 
 void
@@ -61,6 +68,12 @@
     m_spectrumWifiPhy = spectrumWifiPhy;
 }
 
+Ptr<const SpectrumWifiPhy>
+WifiSpectrumPhyInterface::GetSpectrumWifiPhy() const
+{
+    return m_spectrumWifiPhy;
+}
+
 Ptr<NetDevice>
 WifiSpectrumPhyInterface::GetDevice() const
 {
@@ -89,13 +102,35 @@
 WifiSpectrumPhyInterface::SetChannel(const Ptr<SpectrumChannel> c)
 {
     NS_LOG_FUNCTION(this << c);
+    NS_ASSERT_MSG(!m_rxSpectrumModel, "Spectrum channel shall be set before RX spectrum model");
     m_channel = c;
 }
 
+void
+WifiSpectrumPhyInterface::SetRxSpectrumModel(uint32_t centerFrequency,
+                                             uint16_t channelWidth,
+                                             uint32_t bandBandwidth,
+                                             uint16_t guardBandwidth)
+{
+    NS_LOG_FUNCTION(this << centerFrequency << channelWidth << bandBandwidth << guardBandwidth);
+    m_centerFrequency = centerFrequency;
+    m_channelWidth = channelWidth;
+    m_rxSpectrumModel = WifiSpectrumValueHelper::GetSpectrumModel(centerFrequency,
+                                                                  channelWidth,
+                                                                  bandBandwidth,
+                                                                  guardBandwidth);
+}
+
+Ptr<SpectrumChannel>
+WifiSpectrumPhyInterface::GetChannel() const
+{
+    return m_channel;
+}
+
 Ptr<const SpectrumModel>
 WifiSpectrumPhyInterface::GetRxSpectrumModel() const
 {
-    return m_spectrumWifiPhy->GetRxSpectrumModel();
+    return m_rxSpectrumModel;
 }
 
 Ptr<Object>
@@ -104,10 +139,60 @@
     return m_spectrumWifiPhy->GetAntenna();
 }
 
+const FrequencyRange&
+WifiSpectrumPhyInterface::GetFrequencyRange() const
+{
+    return m_frequencyRange;
+}
+
+uint16_t
+WifiSpectrumPhyInterface::GetCenterFrequency() const
+{
+    return m_centerFrequency;
+}
+
+uint16_t
+WifiSpectrumPhyInterface::GetChannelWidth() const
+{
+    return m_channelWidth;
+}
+
+void
+WifiSpectrumPhyInterface::SetBands(WifiSpectrumPhyInterface::WifiSpectrumBands&& bands)
+{
+    m_bands = std::move(bands);
+}
+
+const WifiSpectrumPhyInterface::WifiSpectrumBands&
+WifiSpectrumPhyInterface::GetBands() const
+{
+    return m_bands;
+}
+
+void
+WifiSpectrumPhyInterface::SetRuBands(HePhy::RuBands&& ruBands)
+{
+    m_ruBands = std::move(ruBands);
+}
+
+const HePhy::RuBands&
+WifiSpectrumPhyInterface::GetRuBands() const
+{
+    return m_ruBands;
+}
+
 void
 WifiSpectrumPhyInterface::StartRx(Ptr<SpectrumSignalParameters> params)
 {
-    m_spectrumWifiPhy->StartRx(params);
+    m_spectrumWifiPhy->StartRx(params, this);
+}
+
+void
+WifiSpectrumPhyInterface::StartTx(Ptr<SpectrumSignalParameters> params)
+{
+    params->txPhy = Ptr<SpectrumPhy>(this);
+    params->txAntenna = m_spectrumWifiPhy->GetAntenna();
+    m_channel->StartTx(params);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-spectrum-phy-interface.h ns-3.39/src/wifi/model/wifi-spectrum-phy-interface.h
--- ns-3.38/src/wifi/model/wifi-spectrum-phy-interface.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-spectrum-phy-interface.h	2023-07-05 14:23:48.125428400 -0700
@@ -20,6 +20,9 @@
 #ifndef WIFI_SPECTRUM_PHY_INTERFACE_H
 #define WIFI_SPECTRUM_PHY_INTERFACE_H
 
+#include "spectrum-wifi-phy.h"
+
+#include "ns3/he-phy.h"
 #include "ns3/spectrum-phy.h"
 
 namespace ns3
@@ -46,13 +49,24 @@
      * \return the object TypeId
      */
     static TypeId GetTypeId();
-    WifiSpectrumPhyInterface();
+    /**
+     * Constructor
+     *
+     * \param freqRange the frequency range covered by the interface
+     */
+    WifiSpectrumPhyInterface(FrequencyRange freqRange);
     /**
      * Connect SpectrumWifiPhy object
      * \param phy SpectrumWifiPhy object to be connected to this object
      */
     void SetSpectrumWifiPhy(const Ptr<SpectrumWifiPhy> phy);
 
+    /**
+     * Get SpectrumWifiPhy object
+     * \return Pointer to SpectrumWifiPhy object
+     */
+    Ptr<const SpectrumWifiPhy> GetSpectrumWifiPhy() const;
+
     Ptr<NetDevice> GetDevice() const override;
     void SetDevice(const Ptr<NetDevice> d) override;
     void SetMobility(const Ptr<MobilityModel> m) override;
@@ -62,12 +76,99 @@
     Ptr<Object> GetAntenna() const override;
     void StartRx(Ptr<SpectrumSignalParameters> params) override;
 
+    /**
+     * Get the spectrum channel this interface is attached to
+     *
+     * \return the spectrum channel this interface is attached to
+     */
+    Ptr<SpectrumChannel> GetChannel() const;
+
+    /**
+     * Get the frequency range covered by the spectrum channel this interface is attached to
+     *
+     * \return the frequency range covered by the spectrum channel this interface is attached to
+     */
+    const FrequencyRange& GetFrequencyRange() const;
+
+    /**
+     * Get the center frequency in MHz of the the spectrum channel this interface is attached to
+     *
+     * \return the center frequency in MHz of the the spectrum channel this interface is attached to
+     * to
+     */
+    uint16_t GetCenterFrequency() const;
+
+    /**
+     * Get the channel width in MHz covered by the spectrum channel this interface is attached to
+     *
+     * \return the channel width in MHz covered by the spectrum channel this interface is attached
+     * to to
+     */
+    uint16_t GetChannelWidth() const;
+
+    /**
+     * Start transmission over the spectrum channel
+     *
+     * \param params the parameters of the signal to transmit
+     */
+    void StartTx(Ptr<SpectrumSignalParameters> params);
+
+    /**
+     * Set the RX spectrum model
+     *
+     * \param centerFrequency the center frequency in MHz
+     * \param channelWidth the channel width in MHz
+     * \param bandBandwidth the width of each band in Hz
+     * \param guardBandwidth the width of the guard band in MHz
+     */
+    void SetRxSpectrumModel(uint32_t centerFrequency,
+                            uint16_t channelWidth,
+                            uint32_t bandBandwidth,
+                            uint16_t guardBandwidth);
+
+    /// vector of spectrum bands handled by this interface
+    using WifiSpectrumBands = std::vector<WifiSpectrumBandInfo>;
+
+    /**
+     * Set the vector of spectrum bands handled by this interface
+     *
+     * \param bands vector of spectrum bands
+     */
+    void SetBands(WifiSpectrumBands&& bands);
+    /**
+     * Get the vector of spectrum bands handled by this interface
+     *
+     * \return the vector of spectrum bands
+     */
+    const WifiSpectrumBands& GetBands() const;
+
+    /**
+     * Set the HE RU spectrum bands handled by this interface (if any)
+     *
+     * \param ruBands the HE RU spectrum bands
+     */
+    void SetRuBands(HePhy::RuBands&& ruBands);
+    /**
+     * Get the HE RU spectrum bands handled by this interface
+     *
+     * \return the HE RU spectrum bands
+     */
+    const HePhy::RuBands& GetRuBands() const;
+
   private:
     void DoDispose() override;
 
-    Ptr<SpectrumWifiPhy> m_spectrumWifiPhy; ///< spectrum PHY
-    Ptr<NetDevice> m_netDevice;             ///< the device
-    Ptr<SpectrumChannel> m_channel;         ///< spectrum channel
+    FrequencyRange m_frequencyRange;            ///< frequency range
+    Ptr<SpectrumWifiPhy> m_spectrumWifiPhy;     ///< spectrum PHY
+    Ptr<NetDevice> m_netDevice;                 ///< the device
+    Ptr<SpectrumChannel> m_channel;             ///< spectrum channel
+    uint16_t m_centerFrequency;                 ///< center frequency in MHz
+    uint16_t m_channelWidth;                    ///< channel width in MHz
+    Ptr<const SpectrumModel> m_rxSpectrumModel; ///< receive spectrum model
+
+    WifiSpectrumBands
+        m_bands; /**< Store all the distinct spectrum bands associated with every channels widths */
+    HePhy::RuBands m_ruBands; /**< Store all the distinct spectrum bands associated with every RU */
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-tx-timer.cc ns-3.39/src/wifi/model/wifi-tx-timer.cc
--- ns-3.38/src/wifi/model/wifi-tx-timer.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-tx-timer.cc	2023-07-05 14:23:48.125428400 -0700
@@ -94,29 +94,27 @@
 std::string
 WifiTxTimer::GetReasonString(Reason reason) const
 {
-#define FOO(x)                                                                                     \
+#define CASE_REASON(x)                                                                             \
     case WAIT_##x:                                                                                 \
-        return #x;                                                                                 \
-        break;
+        return #x;
 
     switch (reason)
     {
     case NOT_RUNNING:
         return "NOT_RUNNING";
-        break;
-        FOO(CTS);
-        FOO(NORMAL_ACK);
-        FOO(BLOCK_ACK);
-        FOO(CTS_AFTER_MU_RTS);
-        FOO(NORMAL_ACK_AFTER_DL_MU_PPDU);
-        FOO(BLOCK_ACKS_IN_TB_PPDU);
-        FOO(TB_PPDU_AFTER_BASIC_TF);
-        FOO(QOS_NULL_AFTER_BSRP_TF);
-        FOO(BLOCK_ACK_AFTER_TB_PPDU);
+        CASE_REASON(CTS);
+        CASE_REASON(NORMAL_ACK);
+        CASE_REASON(BLOCK_ACK);
+        CASE_REASON(CTS_AFTER_MU_RTS);
+        CASE_REASON(NORMAL_ACK_AFTER_DL_MU_PPDU);
+        CASE_REASON(BLOCK_ACKS_IN_TB_PPDU);
+        CASE_REASON(TB_PPDU_AFTER_BASIC_TF);
+        CASE_REASON(QOS_NULL_AFTER_BSRP_TF);
+        CASE_REASON(BLOCK_ACK_AFTER_TB_PPDU);
     default:
         NS_ABORT_MSG("Unknown reason");
     }
-#undef FOO
+#undef CASE_REASON
 }
 
 bool
@@ -136,7 +134,7 @@
 Time
 WifiTxTimer::GetDelayLeft() const
 {
-    return Simulator::GetDelayLeft(m_timeoutEvent);
+    return m_end - Simulator::Now();
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-tx-vector.cc ns-3.39/src/wifi/model/wifi-tx-vector.cc
--- ns-3.38/src/wifi/model/wifi-tx-vector.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-tx-vector.cc	2023-07-05 14:23:48.125428400 -0700
@@ -48,6 +48,7 @@
       m_modeInitialized(false),
       m_inactiveSubchannels(),
       m_ruAllocation(),
+      m_center26ToneRuIndication(std::nullopt),
       m_ehtPpduType(1) // SU transmission by default
 {
 }
@@ -83,6 +84,7 @@
       m_modeInitialized(true),
       m_inactiveSubchannels(),
       m_ruAllocation(),
+      m_center26ToneRuIndication(std::nullopt),
       m_ehtPpduType(1) // SU transmission by default
 {
 }
@@ -106,6 +108,7 @@
       m_inactiveSubchannels(txVector.m_inactiveSubchannels),
       m_sigBMcs(txVector.m_sigBMcs),
       m_ruAllocation(txVector.m_ruAllocation),
+      m_center26ToneRuIndication(txVector.m_center26ToneRuIndication),
       m_ehtPpduType(txVector.m_ehtPpduType)
 {
     m_muUserInfos.clear();
@@ -393,21 +396,21 @@
 }
 
 void
-WifiTxVector::SetRuAllocation(const RuAllocation& ruAlloc)
+WifiTxVector::SetRuAllocation(const RuAllocation& ruAlloc, uint8_t p20Index)
 {
     if (ns3::IsDlMu(m_preamble) && !m_muUserInfos.empty())
     {
-        NS_ASSERT(ruAlloc == DeriveRuAllocation());
+        NS_ASSERT(ruAlloc == DeriveRuAllocation(p20Index));
     }
     m_ruAllocation = ruAlloc;
 }
 
 const RuAllocation&
-WifiTxVector::GetRuAllocation() const
+WifiTxVector::GetRuAllocation(uint8_t p20Index) const
 {
     if (ns3::IsDlMu(m_preamble) && m_ruAllocation.empty())
     {
-        m_ruAllocation = DeriveRuAllocation();
+        m_ruAllocation = DeriveRuAllocation(p20Index);
     }
     return m_ruAllocation;
 }
@@ -479,6 +482,12 @@
     return ns3::IsUlMu(m_preamble);
 }
 
+bool
+WifiTxVector::IsAllocated(uint16_t staId) const
+{
+    return m_muUserInfos.count(staId) > 0;
+}
+
 HeRu::RuSpec
 WifiTxVector::GetRu(uint16_t staId) const
 {
@@ -527,54 +536,6 @@
     return m_muUserInfos;
 }
 
-std::pair<std::size_t, std::size_t>
-WifiTxVector::GetNumRusPerHeSigBContentChannel() const
-{
-    if (m_preamble == WIFI_PREAMBLE_EHT_MU && m_ehtPpduType == 1)
-    {
-        return {1, 0};
-    }
-
-    // MU-MIMO is not handled for now, i.e. one station per RU
-    auto ruAllocation = GetRuAllocation();
-    NS_ASSERT_MSG(!ruAllocation.empty(), "RU allocation is not set");
-    if (ruAllocation.size() != m_channelWidth / 20)
-    {
-        ruAllocation = DeriveRuAllocation();
-    }
-    NS_ASSERT_MSG(ruAllocation.size() == m_channelWidth / 20,
-                  "RU allocation is not consistent with packet bandwidth");
-
-    std::pair<std::size_t /* number of RUs in content channel 1 */,
-              std::size_t /* number of RUs in content channel 2 */>
-        chSize{0, 0};
-
-    switch (GetChannelWidth())
-    {
-    case 40:
-        chSize.second += HeRu::GetRuSpecs(ruAllocation[1]).size();
-        [[fallthrough]];
-    case 20:
-        chSize.first += HeRu::GetRuSpecs(ruAllocation[0]).size();
-        break;
-    default:
-        for (auto n = 0; n < m_channelWidth / 20;)
-        {
-            chSize.first += HeRu::GetRuSpecs(ruAllocation[n]).size();
-            chSize.second += HeRu::GetRuSpecs(ruAllocation[n + 1]).size();
-            if (ruAllocation[n] >= 208)
-            {
-                // 996 tone RU occupies 80 MHz
-                n += 4;
-                continue;
-            }
-            n += 2;
-        }
-        break;
-    }
-    return chSize;
-}
-
 void
 WifiTxVector::SetInactiveSubchannels(const std::vector<bool>& inactiveSubchannels)
 {
@@ -596,6 +557,30 @@
     return m_inactiveSubchannels;
 }
 
+void
+WifiTxVector::SetCenter26ToneRuIndication(Center26ToneRuIndication center26ToneRuIndication)
+{
+    if (IsDlMu())
+    {
+        NS_ASSERT(center26ToneRuIndication == DeriveCenter26ToneRuIndication());
+    }
+    m_center26ToneRuIndication = center26ToneRuIndication;
+}
+
+std::optional<Center26ToneRuIndication>
+WifiTxVector::GetCenter26ToneRuIndication() const
+{
+    if (!IsDlMu() || (m_channelWidth < 80))
+    {
+        return std::nullopt;
+    }
+    if (!m_center26ToneRuIndication.has_value())
+    {
+        m_center26ToneRuIndication.emplace(DeriveCenter26ToneRuIndication());
+    }
+    return m_center26ToneRuIndication;
+}
+
 std::ostream&
 operator<<(std::ostream& os, const WifiTxVector& v)
 {
@@ -662,63 +647,33 @@
     return !(*this == other);
 }
 
-ContentChannelAllocation
-WifiTxVector::GetContentChannelAllocation() const
+WifiTxVector::UserInfoMapOrderedByRus
+WifiTxVector::GetUserInfoMapOrderedByRus(uint8_t p20Index) const
 {
-    ContentChannelAllocation channelAlloc{{}};
-
-    if (m_channelWidth > 20)
-    {
-        channelAlloc.emplace_back();
-    }
-
-    for (const auto& [staId, userInfo] : m_muUserInfos)
-    {
-        auto ruType = userInfo.ru.GetRuType();
-        auto ruIdx = userInfo.ru.GetIndex();
-
-        if ((ruType == HeRu::RU_484_TONE) || (ruType == HeRu::RU_996_TONE))
-        {
-            channelAlloc[0].push_back(staId);
-            channelAlloc[1].push_back(staId);
-            continue;
-        }
-
-        size_t numRus{1};
-        if (ruType < HeRu::RU_242_TONE)
-        {
-            numRus = HeRu::m_heRuSubcarrierGroups.at({20, ruType}).size();
-        }
-
-        if (((ruIdx - 1) / numRus) % 2 == 0)
-        {
-            channelAlloc[0].push_back(staId);
-        }
-        else
-        {
-            channelAlloc[1].push_back(staId);
-        }
-    }
-
-    return channelAlloc;
+    auto heRuComparator = HeRu::RuSpecCompare(m_channelWidth, p20Index);
+    UserInfoMapOrderedByRus orderedMap{heRuComparator};
+    std::transform(
+        m_muUserInfos.cbegin(),
+        m_muUserInfos.cend(),
+        std::inserter(orderedMap, orderedMap.end()),
+        [](auto&& userInfo) { return std::make_pair(userInfo.second.ru, userInfo.first); });
+    return orderedMap;
 }
 
 RuAllocation
-WifiTxVector::DeriveRuAllocation() const
+WifiTxVector::DeriveRuAllocation(uint8_t p20Index) const
 {
-    std::all_of(m_muUserInfos.cbegin(), m_muUserInfos.cend(), [&](const auto& userInfo) {
-        return userInfo.second.ru.GetRuType() == m_muUserInfos.cbegin()->second.ru.GetRuType();
-    });
     RuAllocation ruAllocations(m_channelWidth / 20, HeRu::EMPTY_242_TONE_RU);
     std::vector<HeRu::RuType> ruTypes{};
     ruTypes.resize(ruAllocations.size());
-    for (auto it = m_muUserInfos.begin(); it != m_muUserInfos.end(); ++it)
+    const auto& orderedMap = GetUserInfoMapOrderedByRus(p20Index);
+    for (const auto& [ru, staId] : orderedMap)
     {
-        const auto ruType = it->second.ru.GetRuType();
+        const auto ruType = ru.GetRuType();
         const auto ruBw = HeRu::GetBandwidth(ruType);
-        const auto isPrimary80MHz = it->second.ru.GetPrimary80MHz();
+        const auto isPrimary80MHz = ru.GetPrimary80MHz();
         const auto rusPerSubchannel = HeRu::GetRusOfType(ruBw > 20 ? ruBw : 20, ruType);
-        auto ruIndex = it->second.ru.GetIndex();
+        auto ruIndex = ru.GetIndex();
         if ((m_channelWidth >= 80) && (ruIndex > 19))
         {
             // take into account the center 26-tone RU in the primary 80 MHz
@@ -770,4 +725,21 @@
     return ruAllocations;
 }
 
+Center26ToneRuIndication
+WifiTxVector::DeriveCenter26ToneRuIndication() const
+{
+    uint8_t center26ToneRuIndication{0};
+    for (const auto& userInfo : m_muUserInfos)
+    {
+        if ((userInfo.second.ru.GetRuType() == HeRu::RU_26_TONE) &&
+            (userInfo.second.ru.GetIndex() == 19))
+        {
+            center26ToneRuIndication |= (userInfo.second.ru.GetPrimary80MHz())
+                                            ? CENTER_26_TONE_RU_LOW_80_MHZ_ALLOCATED
+                                            : CENTER_26_TONE_RU_HIGH_80_MHZ_ALLOCATED;
+        }
+    }
+    return static_cast<Center26ToneRuIndication>(center26ToneRuIndication);
+}
+
 } // namespace ns3
